function classify_nnet_train(code)
%-------------------------------------------------------------------------------------------------------------
%This program trains a network to simulate the significant amplitudes and latencies of a subject category-----
%how many instances of the signal to be used---

num = 14;
hid1 = 50;
hid2 = 30;
hid3 = 18;
trfun_dir = 'LM'; %must be catalexis of a training algorithm's name! i.e. BFG (for trainbfg), LM (for trainlm) etc
tr_epochs = 100;
valid_set = 3;  %validation set size
%----------------------------------------------
clc;
global cnt
%if called through train_loop function will work for all subjects
if (isempty(cnt)==1)
    clear global cnt;
    cnt = 0;
    while (cnt < 1) | (cnt > num)
        numstr = int2str(num);
        tmp = ['Leave out which subject? (1-' numstr '):   '];
        cnt = input(tmp);
    end
end
clear tmp numstr;

%name of file in which net is to be saved and loaded--------

%-----------------------------------------------------------
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\NN-predict_next\' Type '\' trfun_dir '\' sav];
%-----------------------------------------------------------
%load the appropriate matrix or return error-------------------------------------------
try
    %opening matrices with positions of significant correlations
    cd('C:\MATLAB\work\NN-feature_extr');
    str2 = int2str(cnt);
        if cnt<10
        str2 = ['0' str2];
    end
    temp = ['input_matrix-' code '_' str2];
    load (temp);

    %load data matrices (peaks) from which will acquire specific data
    cd('C:\MATLAB\work\Peaks\Mean');
    temp = [code '_peaks'];
    load (temp);
    
    %creating new matrices for nnet input
    inputA = size(c_amp,2);
    inputL = size(c_lat,2);
    k1 = 1;
    k2 = 1;
    for i=1:num
        for j=1:inputA
            if j==c_amp(k1)
                MATRIX_A(i,k1) = AMP(i,j);
            else
                k1 = k1 + 1;
            end
        end
        for j=1:inputL
            if j==c_lat(k2)
                MATRIX_L(i,k2) = LAT(i,j);
            else
                k2 = k2 + 1;
            end
        end
    end
    
    %saving & deleting data of test subject
    test_A(1:inputA) = MATRIX_A(cnt,:);
    test_L(1:inputL) = MATRIX_L(cnt,:);
    MATRIX_A(cnt,:)=empty();
    MATRIX_L(cnt,:)=empty();
    
    %randomizing matrices (for effective training)
    fperm = randperm(num-1);
    for i=1:num-1
        TEMP_A(i,:) = MATRIX_A(fperm(i),:);
        TEMP_L(i,:) = MATRIX_L(fperm(i),:);
    end
    train_A = TEMP_A;
    train_L = TEMP_L;
    clear TEMP_A TEMP_L fperm;
    
    %creating validation matrices and completing train matrices
    for i=1:valid_set
        valid_A(i,:) = train_A(num+1-i,:);
        train_A(num+1-i,:) = empty();
        valid_L(i,:) = train_L(num+1-i,:);
        train_L(num+1-i,:) = empty();
    end
catch
    disp('Error in loading data matrix for batch training');
    error('Execute function make_batch_matrix with the appropriate parameters');
end
%--------------------------------------------------------------------------------------

%training the network-----------------------------------------
p{1} = MATRIX(lin-1,:);
t{1} = MATRIX(lin,:);
for i=1:(lin-2)
    Pi{i}=MATRIX(i,:);
end
clear MATRIX;
VV.P{1} = VALID(lin-1,:);
VV.T{1} = VALID(lin,:);
for i=1:(lin-2)
    VV.Pi{i}=VALID(i,:);
end

disp('Network building and training');
disp('----------------------------------------------------------------------------------------------------------------------------');

%defining the network----------------------
%save files using real number of subject
cnter = used_subj(cnt);
cntstr = int2str(cnter);
if cnter < 10
    cntstr = ['0' cntstr];
end
%---------------------------------------
str = sav = ['nnet_' code '_' str2 '.mat'];
strpic = [code '_train_perf(' ststr '-' finstr ')ex' cntstr];
strx2 = [S2 '\' str];
temp = exist (strx2);
tr_str = ['train' trfun_dir];
if temp ~= 0
    load (str);
    net.trainParam.minstep = 1e-08;
    net.trainParam.goal = 0;
    net.trainParam.epochs = 2;
    epotmp = epo;
else
    %building custom network
    net = network
    net.numInputs = 2;
    net.numLayers = 3;
    net.biasConnect = [1; 1; 1];
    net.inputConnect = [1 0; 0 1; 0 0];
    net.layerConnect = [0 0 0; 0 0 0; 1 1 0];
    net.outputConnect = [0 0 1];
    net.targetConnect = [0 0 1];
    %defining amplitude input details
    net.inputs{1}.size = inputA;
    for i=1:inputA
        net.inputs{1}.range(i,1) =-30;
        net.inputs{1}.range(i,2) = 30;
    end
    %defining latency input details
    net.inputs{2}.size = inputL;
    for i=1:inputL
        net.inputs{2}.range(i,1) = 0;
        net.inputs{2}.range(i,2) = 1020;
    end
    %about layer 1
    net.layers{1}.size = inputA;
    net.layers{1}.transferFcn = 'tansig';
    net.layers{1}.initFcn = 'initnw';
    %about layer 2
    net.layers{2}.size = inputL;
    net.layers{2}.transferFcn = 'tansig';
    net.layers{2}.initFcn = 'initnw';
    %about layer 3
    net.layers{3}.size = 1
    net.layers{3}.transferFcn = 'purelin';
    net.layers{3}.initFcn = 'initnw';
    
    if hid3 == 0
        net = newfftd([-1 1],[0:1:delays_number],[hid1 hid2 1],{'tansig' 'tansig' 'purelin'},tr_str);
    else
        net = newfftd([-1 1],[0:1:delays_number],[hid1 hid2 hid3 1],{'tansig' 'tansig' 'tansig' 'purelin'},tr_str);
    end
    net.trainParam.goal = 0;
    net.trainParam.mem_reduc = 1;
    net.trainParam.lr = 0.1;
    net.trainParam.epochs = tr_epochs;
    net.trainParam.show = 1;
    net.trainParam.minstep = 1e-20;
    epotmp = 0;
end
clear temp;
%------------------------------------------
strhid1 = int2str(hid1);
strhid2 = int2str(hid2);
if hid3 == 0
    newtmpstr = [strhid1 '-' strhid2 '('ststr '-' finstr ')'];
else
    strhid3 = int2str(hid3);
    newtmpstr = [strhid1 '-' strhid2 '-' strhid3 '('ststr '-' finstr ')'];
end
try
    cd (newtmpstr);
catch
    mkdir(S2,newtmpstr);
    cd (newtmpstr);
end
    [net,tr] = train(net,p,t,Pi,[],VV);
    epo = tr.epoch(end) + epotmp;
    perf = tr.perf(end);
    save (str,'net','epo','perf');%,'maxM','minM'
    print('-dbmp', '-r80', strpic);

%------------------------------------------
%--------------------------------------------------------------