function flag_corellations(categ,subj)
%categ=OCD,FES,Controls
%subj=the number of the subject that will be
%left out for use in the testing process
category = {'Controls' 'OCD'};

%enter the appropriate location and load array
dirname=['C:\MATLAB\work\Peaks\Mean'];
cd (dirname);
tmpstr = [categ '_peaks'];
load(tmpstr)

%deleting case row from AMP,LAT (peaks for subject selected)
AMP = empty2(AMP,subj,'L');
LAT = empty2(LAT,subj,'L');

%correlation matrices 120X120
corr_amp = corrcoef(AMP);
corr_lat = corrcoef(LAT);
A(1:120)=0;
L(1:120)=0;
clear AMP LAT;

%opening the data of the other category
%so that correlation differences can be
%observed
if strcmp(categ, category{1}) == 1
    tmpstr = [category{2} '_peaks'];
    load(tmpstr);
else
    tmpstr = [category{1} '_peaks'];
    load(tmpstr);
end
%deleting case row from AMP,LAT (peaks for subject selected)
AMP = empty2(AMP,subj,'L');
LAT = empty2(LAT,subj,'L');
%correlation matrices 120X120
c_a_t = corrcoef(AMP);
c_l_t = corrcoef(LAT);
A_t(1:120)=0;
L_t(1:120)=0;
clear AMP LAT;


%finding the # of significant correlations for each line of arrays  A, L
%(each line corresponds to a peak of a node: i.e P600 of node 02)
for i=1:120
    for j=1:120
        if (corr_amp(i,j)>0.6 | corr_amp(i,j)<-0.6) & ~(c_a_t(i,j)>0.6 | c_a_t(i,j)<-0.6)
            A(i) = A(i) + 1;
        end
        if (corr_lat(i,j)>0.6 | corr_lat(i,j)<-0.6) & ~(c_l_t(i,j)>0.6 | c_l_t(i,j)<-0.6)
            L(i) = L(i) + 1;
        end
    end
end

%finding line with most significant correlations for arrays A, L
max_amp = 0;
max_lat = 0;
for i=1:120
    if A(i) >= max_amp
        max_amp = A(i);
        pos_a = i;
    end
    if L(i) >= max_lat
        max_lat = L(i);
        pos_l = i;
    end
end


%marking in two matrices c_amp(1:max_amp) & c_lat(1:max_lat)
%the positions of the correlated peaks that will be used in the nnet
counter1 = 0;
counter2 = 0;
for j=1:120
    if ((corr_amp(pos_a,j)>0.6 | corr_amp(pos_a,j)<-0.6) & ~(c_a_t(pos_a,j)>0.6 | c_a_t(pos_a,j)<-0.6)) | j == pos_a
        counter1 = counter1 + 1;
        c_amp(counter1) = j;
    end
    if ((corr_lat(pos_l,j)>0.6 | corr_lat(pos_l,j)<-0.6) & ~(c_l_t(pos_l,j)>0.6 | c_l_t(pos_l,j)<-0.6)) | j == pos_l
        counter2 = counter2 + 1;
        c_lat(counter2) = j;
    end
end

%save c_amp c_lat, pos_a, pos_l
cd('C:\MATLAB\work\NN-feature_extr');
subjstr = int2str(subj);
if subj <10
    subjstr = ['0' subjstr];
end
temp = ['input_matrix-' categ '_' subjstr];
save (temp,'c_amp','c_lat','pos_a','pos_l','subj');