function classify_nnet2_train
%-------------------------------------------------------------------------------------------------------------

num = 14;
trfun_dir = 'BFG'; %must be catalexis of a training algorithm's name! i.e. BFG (for trainbfg), LM (for trainlm) etc
tr_epochs = 100;
valid_set = 3;  %validation set size
%----------------------------------------------
global cnt
%if called through train_loop function will work for all subjects
if (isempty(cnt)==1)
    clear global cnt;
    cnt = 0;
    while (cnt < 1) | (cnt > num)
        numstr = int2str(num);
        tmp = ['Leave out which subject? (1-' numstr '):   '];
        cnt = input(tmp);
    end
end
clear tmp numstr;

category = {'Controls' 'FES'};
for categ = 1:2
    %load the appropriate matrix or return error
    try
        %build string
        str2 = int2str(cnt);
        if cnt<10
            str2 = ['0' str2];
        end
        
        %load data matrices (peaks) from which will acquire specific data
        clear AMP LAT;
        cd('C:\MATLAB\work\Peaks\Mean');
        temp = [category{categ} '_peaks'];
        load (temp);
        
        %preprocessing the matrices
        %and concatenating them
        %Amplitudes
        if categ==1
            minM_A(1:num) = -30;%min(min(AMP));
            maxM_A(1:num) = 30; %max(max(AMP));
            maxM_A = maxM_A';minM_A = minM_A';
            AMP1 = tramnmx(AMP,minM_A,maxM_A);
        else
            AMP2 = tramnmx(AMP,minM_A,maxM_A);
            AMP = cat(1,AMP1,AMP2);
            minM_A = minM_A(1);
            maxM_A = maxM_A(1);
        end   
        %Latencies
        if categ==1
            minM_L(1:num) = 0;%min(min(LAT));
            maxM_L(1:num) = 1020;%max(max(LAT));
            maxM_L = maxM_L';minM_L = minM_L';
            LAT1 = tramnmx(LAT,minM_L,maxM_L);
        else
            LAT2 = tramnmx(LAT,minM_L,maxM_L);
            LAT = cat(1,LAT1,LAT2);
            minM_L = minM_L(1);
            maxM_L = maxM_L(1);
        end
    catch
        disp('Error in loading peak matrix for training');
    end
end

    %saving & deleting data of test subject
    test_A{1} = AMP(cnt,:);
    test_A{2} = AMP(cnt+num,:);
    test_L{1} = LAT(cnt,:);
    test_L{2} = LAT(cnt+num,:);
    MATRIX_A = empty2(AMP,cnt+num,'L');
    MATRIX_A = empty2(MATRIX_A,cnt,'L');
    MATRIX_L = empty2(LAT,cnt+num,'L');
    MATRIX_L = empty2(MATRIX_L,cnt,'L');
    
    %creating validation matrices and completing train matrices
    for i=1:valid_set
        valid_A(valid_set+i,:) = MATRIX_A(size(MATRIX_A,1),:);
        MATRIX_A = empty2(MATRIX_A,size(MATRIX_A,1),'L');
        valid_L(valid_set+i,:) = MATRIX_L(size(MATRIX_L,1),:);
        MATRIX_L = empty2(MATRIX_L,size(MATRIX_L,1),'L');
    end
    for i=1:valid_set
        valid_A(i,:) = MATRIX_A(num-i,:);
        MATRIX_A = empty2(MATRIX_A,num-i,'L');
        valid_L(i,:) = MATRIX_L(num-i,:);
        MATRIX_L = empty2(MATRIX_L,num-i,'L');
    end
    train_A = MATRIX_A;
    train_L = MATRIX_L;
    
    %targets
    train_tar_A(1:size(train_A,1)/2) = 1;
    train_tar_A(size(train_A,1)/2+1:size(train_A,1)) = 0;
    valid_tar_A(1:size(valid_A,1)/2) = 1;
    valid_tar_A(size(valid_A,1)/2+1:size(valid_A,1)) = 0;
    train_tar_L(1:size(train_L,1)/2) = 1;
    train_tar_L(size(train_L,1)/2+1:size(train_L,1)) = 0;
    valid_tar_L(1:size(valid_L,1)/2) = 1;
    valid_tar_L(size(valid_L,1)/2+1:size(valid_L,1)) = 0;
    clear MATRIX_A MATRIX_L;
    
    %randomizing matrices for better performance
    perm1 = randperm(size(train_A,1));
    for i=1:size(perm1,2)
        temp_train_A(i,:) = train_A(perm1(i),:);
        temp_train_tar_A(i) = train_tar_A(perm1(i));
        temp_train_L(i,:) = train_L(perm1(i),:);
        temp_train_tar_L(i) = train_tar_L(perm1(i));
    end
    train_A = temp_train_A;
    train_L = temp_train_L;
    train_tar_A = temp_train_tar_A;
    train_tar_L = temp_train_tar_L;
    clear temp_train_A temp_train_L temp_train_tar_A temp_train_tar_L;
    
    %building appropriate directory (according to training function)
    %and a text info file
    cd ('C:\MATLAB\work\NN-feature_extr2\Classify');
    try
        cd(trfun_dir);
    catch
        mkdir(trfun_dir);
        cd(trfun_dir);
    end
    if fopen('amplitude_results.txt') == -1
        txt = fopen('amplitude_results.txt','at');
        tmpstr = ['Target is 1 for controls and 0 for patients\n'];
        fprintf(txt,tmpstr);
        tmpstr = ['\t\t' categ{1} '\t\t' categ{2} '\n'];
        fprintf(txt,tmpstr);
    end
    fclose('all');
    if fopen('latency_results.txt') == -1
        txt = fopen('latency_results.txt','at');
        tmpstr = ['Target is 1 for controls and 0 for patients\n'];
        fprintf(txt,tmpstr);
        tmpstr = ['\t\t' categ{1} '\t\t' categ{2} '\n'];
        fprintf(txt,tmpstr);
    end
    fclose('all');    

    
    %AMPLITUDE NETWORK
    disp('Network building and training');
    temp = ['Amplitudes prediction network - ' str2];
    disp(temp); clear temp;
    disp('-------------------------------------------');
    if size(NAMP,2)<2
        error('very few significant correlations - cannot build network');
    end
    
    %building input for train and validation sets
    %train set - input
    N=size(NAMP,2);
    counter=0;
    for i=N:-1:1
        XN=size(NAMP{i},2);
        for j=1:XN
            counter=counter+1;
            P{counter,1}=NAMP{i}{j}{1}';
    
    for k=1:8
        for j1=1:15
            for j2=1:size(train_A,1)
                P{k,1}(j1,j2) = train_A(j2,(j1-1)*8+k);
            end
        end
    end
    %train set - target
    T{1} = train_tar_A;
    %validation set - input
    for k=1:8
        for j1=1:15
            for j2=1:size(valid_A,1)
                VV.P{k,1}(j1,j2) = valid_A(j2,(j1-1)*8+k);
            end
        end
    end
    %validation set - target
    VV.T{1} = valid_tar_A;
    
    %building custom network
    net = network;
    %# of inputs
    net.numInputs = 8;
    %# of layers
    net.numLayers = 9;
    %bias
    net.biasConnect = [1; 1; 1; 1; 1; 1; 1; 1; 1];
    %input connection
    tempA(9,8) = 0;
    for j =1:8
        tempA(j,j)=1;
    end
    net.inputConnect = tempA;
    clear tempA;
    %layer connection (ALTER THIS)
    tempA(9,9) = 0;
    for j=1:8
        tempA(j+1,j)=1;
    end
    net.layerConnect = tempA;
    clear tempA;
    %output and target connection
    net.outputConnect = [0 0 0 0 0 0 0 0 1];
    net.targetConnect = [0 0 0 0 0 0 0 0 1];
    %defining input size & range
    for j=1:8
        net.inputs{j}.size = 15;
        for jz=1:15
            net.inputs{j}.range(jz,1) =-1;
            net.inputs{j}.range(jz,2) = 1;
        end
    end
    
    %about layers 1-8
    for j=1:8
        net.layers{j}.size = 15;
        net.layers{j}.transferFcn = 'tansig';
        net.layers{j}.initFcn = 'initnw';
    end
    %about layer 9
    net.layers{9}.size = 1;
    net.layers{9}.transferFcn = 'purelin';
    net.layers{9}.initFcn = 'initnw';
    
    %net functions
    net.initFcn = 'initlay';
    net.performFcn = 'mse';
    temps = ['train' trfun_dir];
    net.trainFcn = temps;
    clear temps;
    
    %training the network
    [net,tr] = train(net,P,T,[],[],VV);
    epoA = tr.epoch(end);
    perfA = tr.perf(end);
    
    %saving the network
    sav = ['amp_' str2 '.mat'];
    strpic = ['amp_' str2];
    save (sav,'net','epoA','perfA','test_A');
    print('-dbmp', '-r80', strpic);
    
    %simulating network
    [Y1] = sim(net,test_A{1});
    [Y2] = sim(net,test_A{2});
    %saving amp result in text file
    txt = fopen('amplitude_results.txt','at');
    tmp_info_str = ['net 1 ' '\t\t' Y1 '\t\t' Y2 '\n'];
    fprintf(txt, tmp_info_str);
    fclose(txt);
    clear tmp_info_str txt;
    
    clear net p VV epoA perfA minM_A minM_L test_A P T;


    %LATENCY NETWORK
    disp('Network building and training');
    temp = ['Latencies prediction network - ' str2];
    disp(temp); clear temp;
    disp('----------------------------------------');

    %building input for train and validation sets
    %train set - input
    for k=1:8
        for j1=1:15
            for j2=1:size(train_L,1)
                P{k,1}(j1,j2) = train_L(j2,(j1-1)*8+k);
            end
        end
    end
    %train set - target
    T{1} = train_tar_L;
    %validation set - input
    for k=1:8
        for j1=1:15
            for j2=1:size(valid_L,1)
                VV.P{k,1}(j1,j2) = valid_L(j2,(j1-1)*8+k);
            end
        end
    end
    %validation set - target
    VV.T{1} = valid_tar_L;
    
    %building custom network
    net = network;
    %# of inputs
    net.numInputs = 8;
    %# of layers
    net.numLayers = 9;
    %bias
    net.biasConnect = [1; 1; 1; 1; 1; 1; 1; 1; 1];
    %input connection
    tempL(9,8) = 0;
    for j =1:8
        tempL(j,j)=1;
    end
    net.inputConnect = tempL;
    clear tempL;
    %layer connection (ALTER THIS)
    tempL(9,9) = 0;
    for j=1:8
        tempL(j+1,j)=1;
    end
    net.layerConnect = tempL;
    clear tempL;
    %output and target connection
    net.outputConnect = [0 0 0 0 0 0 0 0 1];
    net.targetConnect = [0 0 0 0 0 0 0 0 1];
    %defining input size & range
    for j=1:8
        net.inputs{j}.size = 15;
        for jz=1:15
            net.inputs{j}.range(jz,1) =-1;
            net.inputs{j}.range(jz,2) = 1;
        end
    end
    
    %about layers 1-8
    for j=1:8
        net.layers{j}.size = 15;
        net.layers{j}.transferFcn = 'tansig';
        net.layers{j}.initFcn = 'initnw';
    end
    %about layer 9
    net.layers{9}.size = 1;
    net.layers{9}.transferFcn = 'purelin';
    net.layers{9}.initFcn = 'initnw';
    
    %net functions
    net.initFcn = 'initlay';
    net.performFcn = 'mse';
    temps = ['train' trfun_dir];
    net.trainFcn = temps;
    clear temps;
    
    %training the network
    [net,tr] = train(net,P,T,[],[],VV);
    epoL = tr.epoch(end);
    perfL = tr.perf(end);
    
    %saving the network
    sav = ['lat_' str2 '.mat'];
    strpic = ['lat_' str2];
    save (sav,'net','epoL','perfL','test_L');
    print('-dbmp', '-r80', strpic);
    
    %simulating network
    [Y1] = sim(net,test_L{1});
    [Y2] = sim(net,test_L{2});
    %saving amp result in text file
    txt = fopen('latency_results.txt','at');
    tmp_info_str = ['net 1 ' '\t\t' Y1 '\t\t' Y2 '\n'];
    fprintf(txt, tmp_info_str);
    fclose(txt);
    clear tmp_info_str txt;
    
    clear net p P T VV epoL perfL test_A test_L;