function flag_c(categ,subj)
%categ=OCD,FES,Controls
%subj=the number of the subject that will be
%left out for use in the testing process
%this function flags the node that has the P600 with the most strong correlations with other peaks
category = {'Controls' 'OCD'};
warning off;

%enter the appropriate location and load array
dirname=['C:\MATLAB\work\Peaks\Mean'];
cd (dirname);
tmpstr = [categ '_peaks'];
load(tmpstr);
AMP2 = AMP;
LAT2 = LAT;

%loading the other category's array to grab test data
if strcmp(category{1},categ)==1
    tmpstr = [category{2} '_peaks'];
else
    tmpstr = [category{1} '_peaks'];
end
load(tmpstr);

%processing AMP2,LAT2,AMP,LAT so that peaks are arranged by type - not lead.
metr = 0;
for i=1:8
    for j=i:8:120
        metr = metr + 1;
        AMPL(:,metr) = AMP2(:,j);
        LATE(:,metr) = LAT2(:,j);
        AMPX(:,metr) = AMP(:,j);
    end
end
clear AMP2 LAT2;

%test data of other category
TAMPX(1,:) = AMPX(subj,:);
clear AMPX;

%saving and deleting case row from AMPL,LATE (peaks for subject selected)
TAMP(1,:) = AMPL(subj,:);
TLAT(1,:) = LATE(subj,:);
AMPL = empty2(AMPL,subj,'L');
LATE = empty2(LATE,subj,'L');

%correlation matrices 120X120
corr_amp = corrcoef(AMPL);
corr_lat = corrcoef(LATE);
A(1:120)=0;
L(1:120)=0;

%preprocessing AMPL so that data fall in [-1,1]
minM_A(1:size(AMPL,1)) = -30;%min(min(AMP));
maxM_A(1:size(AMPL,1)) = 30; %max(max(AMP));
maxM_A = maxM_A';minM_A = minM_A';
AMP1 = tramnmx(AMPL,minM_A,maxM_A);
TAMP1 = tramnmx(TAMP,-30,30);
TAMPX1 = tramnmx(TAMPX,-30,30);

%finding the # of significant correlations for each peak, to the
%immediately previous peak. i.e.: P300 with N200 etc
A(1:8)=0;L(1:8)=0;
for i=16:120
    k = (i - 1) - mod(i-1,15);
    for j=k-14:k
        if (corr_amp(i,j)>0.7 | corr_amp(i,j)<-0.7)
            A(i) = A(i) + 1;
        end
        if (corr_lat(i,j)>0.7 | corr_lat(i,j)<-0.7)
            L(i) = L(i) + 1;
        end
    end
end

%cell array NAMP{nnet layer}{Number}{Type}  -  type=1 => values, train and validation
                                             % type=2 => children connectivity
                                             % type=3 => parent connectivity
                                             % type=4 => value, test sets
                                             % type=5 => number relative to the net's size
%P600-layer1
counter=0;
LV=0;
for j=106:120
    counter1=0;
    if A(j)>0
        LV=1;
        counter=counter+1;
        NAMP{1}{counter}{1}=AMP1(:,j);
        NAMP{1}{counter}{4}(1)=TAMP1(j);
        NAMP{1}{counter}{4}(2)=TAMPX1(j);
        for i=91:105
            if (corr_amp(j,i)>0.8 | corr_amp(j,i)<-0.8)
                counter1 = counter1 + 1;
                NAMP{1}{counter}{2}(counter1)=i;        
            end
        end
    end
end

%N400-layer2
if counter~=0
    counterx(1:15)=0;
    D=0;
    m=0;
    for j=91:105
        m=m+1;
        for i=1:counter
            for k=1:size(NAMP{1}{i}{2},2)
                if NAMP{1}{i}{2}(k) == j
                    counterx(m)=counterx(m)+1;
                    TEMP{j}(counterx(m))=i;
                    D=1;
                end
            end
        end
    end
    counter=0;
    if D==1;
    for j=1:size(TEMP,2)
        counter1=0;
        if isempty(TEMP{j})==0
            counter=counter+1;
            NAMP{2}{counter}{1}=AMP1(:,j);
            NAMP{2}{counter}{4}(1)=TAMP1(j);
            NAMP{2}{counter}{4}(2)=TAMPX1(j);
            NAMP{2}{counter}{3}=TEMP{j};
        end
    end
    clear TEMP;
end
end

if LV==1
%randomizing NAMP{x}{x}{1}
bs = size(NAMP{1}{1}{1},1);
xp = randperm(bs);
for i=1:size(NAMP,2)
    for j=1:size(NAMP{i},2)
        for k=1:bs
            TEMP(k,1) = NAMP{i}{j}{1}(xp(k));
        end
        NAMP{i}{j}{1} = TEMP;
        clear TEMP;
    end
end
end

%assigning an overall number to each node of the nnet to be.
%it will be used for the layer connection later on
%the procedure doesn't include the first cell of NAMP: it is target, not layer
LN=0;
for k=size(NAMP,2):-1:2;
    for i=1:size(NAMP{k},2)
        LN = LN + 1;
        NAMP{k}{i}{5} = LN; %temp info
    end
end

%save NAMP NLAT
try
    cd('C:\MATLAB\work\NN-feature_extr4');
catch
    cd('C:\MATLAB\work\');
    mkdir('NN-feature_extr4');
    cd('NN-feature_extr4');
end
subjstr = int2str(subj);
if subj <10
    subjstr = ['0' subjstr];
end
temp = ['input_mat-' categ '_' subjstr];
if isempty(NAMP)==0
    save (temp,'NAMP','subj','bs'); %'NLAT'
else
    save (temp,'subj');
end